// Arguments passed into this controller can be accessed via the `$.args` object directly or:
var args = $.args;

// Obtain collections and their data
var dailySingleTime = Alloy.Collections.dailySingleTime;
var dailySingleTimeWeek = Alloy.Collections.dailySingleTimeWeek;

var dailyMultiTime = Alloy.Collections.dailyMultiTime;
var dailyMultiTimeWeek = Alloy.Collections.dailyMultiTimeWeek;

var weeklySingleTime = Alloy.Collections.weeklySingleTime;
var weeklySingleTimeWeek = Alloy.Collections.weeklySingleTimeWeek;

var challengelySingleTime = Alloy.Collections.challengelySingleTime;
var challengelySingleTimeWeek = Alloy.Collections.challengelySingleTimeWeek;

// Variable to store today's date
var date;

// Formats a date nicely like 'June 28'
var months = new Array('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December');
function formatDate (aDate) {
	var day = aDate.getDate();
	var monthNumber = parseInt(aDate.getMonth());
	var monthText = months[monthNumber];
	return (monthText + ' ' + day);
}

// Gets todays date
function todaysDate () {
	return (new Date());
}

// Updates a collection based on the current date - used by changeDate
function updateCollection (collection, formattedDate) {
	var table = collection.config.adapter.collection_name;
	collection.fetch({
		query: 'Select * from ' + table + ' where date="' + formattedDate + '"'
	});
}

var daysOfTheWeek = [
	"Sunday",
	"Monday",
	"Tuesday",
	"Wednesday",
	"Thursday",
	"Friday",
	"Saturday"
];

function dayOfWeekFor (date) {
	return daysOfTheWeek[date.getDay()];
}

Alloy.Globals.reloadTitle = function() {
	$.dateInstance.save({
		text: formatDate(date),
		name: Ti.App.Properties.getString('name', 'Title'),
		dayOfWeek: dayOfWeekFor(date)
	});
};

// Changes the date examined by the application to a new one
function changeDate (newDate) {
	// Perform cleanup
	$.off(); // Remove all the event listeners that were added previously so new ones can be created
	date = newDate; // Set the date
	var formattedDate = formatDate(date);
	// Requery the data collection for the new date
	updateCollection(dailySingleTime, formattedDate);
	updateCollection(dailyMultiTime, formattedDate);
	updateCollection(weeklySingleTime, formattedDate);
	updateCollection(challengelySingleTime, formattedDate);
	// Sync the date to the model
	$.dateInstance.save({
		text: formattedDate,
		name: Ti.App.Properties.getString('name', 'Title'),
		dayOfWeek: dayOfWeekFor(newDate)
	});
}

// Actually change the examined date to today's date
changeDate(todaysDate());

// Switches the date to the date before whatever the current date is - used for navigation
function switchDateBefore () {
}

// Switches the date to the date after whatever the current date is - used for navigation
function switchDateAfter () {
	
}

var tColor, iColor, nColor;



if (OS_IOS) {
	tColor = "#40FF00";
	iColor = "#40FF00";
	nColor = "#FFFFFF";
}


if (OS_ANDROID) {
	tColor = "#006400"; // Dark Green
	iColor = "#006400"; // Dark Green
	nColor = "#414141";
}

/*
if (OS_ANDROID) {
	tColor="#B6B6B6";
	iColor = "#B6B6B6";
	nColor = "#414141";
}
*/

// Gets the proper background color for an activity based on if its been performed too many times
function correctBackgroundColor (tooManyTimes, individualDone) {
	if (tooManyTimes) {
		//return "#D3D3D3"; // poor color choice
		return tColor; // better color choice
	} else {
		if (individualDone) {
			return iColor; 
		} else {
			return nColor;
		}
	}
}

// -------------------------- Event listeners that change the state of the model to reflect user input (basically saying if an activity has been completed or not) ----------------

// Change the model based on the changes in the switch for the daily single activities
function dailySingleTimeSwitch (event) {
	
}

// Change the model based on the changes in the siwtch for the weekly single activities
function weeklySingleTimeSwitch (event) {
	
}

// Change the model based on the changes in the switch for the challengely single activities
function challengelySingleTimeSwitch (event) {
	
}

// Decrease the number of times a daily multi activity has been performed today
function decreaseTimesDaily (event) {
	
}

// Increase the number of times a daily multi activity has been performed today
function increaseTimesDaily (event) {
	
}

// Max out the number of times a daily multi activity has been completed
function increaseincreaseTimesDaily (event) {
	
}

// ---------------- Event listening methods for displaying informational modals ------------------

function openNavModal (event) {
	var modal = Alloy.createController('navigationModal', {
		date: date,
		changeDate: changeDate
	});
	modal.openModal();
}

// Displays a modal that provides extra information about the clicked activity
function displayInfoModalDailySingle (event) {
	
	modal.openModal();
}

// Displays a modal that provides extra information about the clicked activity
function displayInfoModalDailyMulti (event) {
	
	modal.openModal();
}

// Displays a modal that provides extra information about the clicked activity
function displayInfoModalWeeklySingle (event) {
	
	modal.openModal();
}

// Displays a modal that provides extra information about the clicked activity
function displayInfoModalChallengelySingle (event) {
	
	modal.openModal();
}

// ------------------------ Transformation functions used to initially decide the proper coloration for the activities -----------------

function dailySingleTimeTransform (model) {
	var transformed = model.toJSON();
	  
	return transformed;
}

function dailyMultiTimeTransform (model) {
	var transformed = model.toJSON();
	
	return transformed;
}

function weeklySingleTimeTransform (model) {
	var transformed = model.toJSON();
	
	return transformed;
}

function challengelySingleTimeTransform (model) {
	var transformed = model.toJSON();
	
	return transformed;
}

$.cleanup = function cleanup() {

  // let Alloy clean up listeners to global collections for data-binding
  // always call it since it'll just be empty if there are none
  $.destroy();
  
  $.dateInstance.destroy();

  // remove all event listeners on the controller
  $.off();

  // remove any listeners you added to global proxies
  Ti.Gesture.removeEventListener('orientationchange', onOrientationChange);

  // and custom global dispatchers (all at once, via context)
  myDispatcher.off(null, null, $);

  // in turn, let controllers of required views clean up
  $.requiredView.cleanup();

  // and close windows of controllers you created, triggering them to clean up as well
  someWindow.getView().close();

  // this is not needed if someController cleans up well and we have the only reference
  // someController = null;
};

// you could also do this via the view's onClose attribute
$.daily_tab_window.addEventListener('close', $.cleanup);

// Function that sorts models based on their ordering
function orderingSort (a, b) {
	return 1;
}

// Filter that only displays models of the current date and sorts them based on their ordering
function dateAndOrderFilter (collection) {
	var filteredModels=[];

	return filteredModels;
}