var moment = require('alloy/moment');

// model initialization and retrival
var dailySingleTime = Alloy.Collections.dailySingleTime;
dailySingleTime.fetch();
var dailySingleTimeWeek = Alloy.Collections.dailySingleTimeWeek;
dailySingleTimeWeek.fetch();

var dailyMultiTime = Alloy.Collections.dailyMultiTime;
dailyMultiTime.fetch();
var dailyMultiTimeWeek = Alloy.Collections.dailyMultiTimeWeek;
dailyMultiTimeWeek.fetch();

var weeklySingleTime = Alloy.Collections.weeklySingleTime;
weeklySingleTime.fetch();
var weeklySingleTimeWeek = Alloy.Collections.weeklySingleTimeWeek;
weeklySingleTimeWeek.fetch();

var challengelySingleTime = Alloy.Collections.challengelySingleTime;
challengelySingleTime.fetch();
var challengelySingleTimeWeek = Alloy.Collections.challengelySingleTimeWeek;
challengelySingleTimeWeek.fetch();

var challenges = Alloy.Collections.challenge;
challenges.fetch();

var mySettings = Alloy.Models.instance('settings');

// Wipes a collection of having anything in it anymore
function wipeCollectionAndMakeTables (db, collectionName, collectionDefinition) {
	db.execute('DROP TABLE IF EXISTS ' + collectionName);
	db.execute('CREATE TABLE IF NOT EXISTS ' + collectionName + ' ' + collectionDefinition);
	db.execute('DELETE FROM ' + collectionName);
}

// Populate the settings and database if the application has never been loaded before
var loaded = Ti.App.Properties.getBool('loaded', false);

// This function must be called after settings are loaded
function getStartDate() {
	return moment();
}

function getEndDate() {
	return moment();
}

// Formats a date nicely like 'June 28'
var months = new Array('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December');
function formatDate (aDate) {
	var day = aDate.getDate();
	var monthNumber = parseInt(aDate.getMonth());
	var monthText = months[monthNumber];
	return (monthText + ' ' + day);
}

var id = 0;
function uniqueID() {
	id++;
	return (id - 1);
}

// Load the DailySingleTime Activities
function loadDailySingle (weeks, dailySingles, db) {
	return;
}

// Load the DailyMultiTime Activities
function loadDailyMulti (weeks, dailyMultis, db) {
	return;
}

// Load the WeeklySingleTime Activities
function loadWeeklySingle (weeks, weeklySingles, db) {
	return;
}

// Load the ChallengelySingleTime Activities
function loadChallengelySingle (weeks, challengelySingles, db) {
	return;
}


// set settings
mySettings.fetch(); // fetch existing settings
mySettings.save({ // save settings
	title: "",
	dates: "",
	logByDate: "",
	description: "",
	creditName: "",
	name: "",
	weekOrder: "",
	notifications: ""
});

// function for loading the application
function doLoading() {
	loaded = true;
	Ti.App.Properties.setBool('loaded', loaded);
}

function versionHasChanged() {
	return false;
}

if (!loaded || versionHasChanged()) {
	doLoading();
}

Alloy.Globals.doneLoading();
// Set desired tab based on date
var now = moment();
var startDate = moment(getStartDate());
var endDate = moment(getEndDate());
if (now < startDate) {
	$.tab_group.setActiveTab(0); // Show Description tab 1st before challenge
} else if (now > endDate) {
	$.tab_group.setActiveTab(2); // Show Progress tab 1st after challenge
} else {
	$.tab_group.setActiveTab(1); // Show Activity Log tab 1st during challenge
}

$.tab_group.open(); // only show the page after initialization completes
Alloy.Globals.reloadTitle(); // reload the title because it doesn't come up right (this shouldn't be a global but oh well)
